Ice Reference Documentation
<<< Previous | Properties | Next >>>

# Freeze Properties

## Freeze.DbEnv.`env-name`.CheckpointPeriod

### Synopsis

    Freeze.DbEnv.env-name.CheckpointPeriod=num

### Description

Every Berkeley DB environment created by Freeze has an associated thread that checkpoints this environment every `num` seconds. If `num` is less than 0, no checkpoint is performed. Defaults to 120 seconds.

## Freeze.DbEnv.`env-name`.DbHome

### Synopsis

    Freeze.DbEnv.env-name.DbHome=db-home

### Description

Defines the home directory of this Freeze database environment. Defaults to `env-name`.

## Freeze.DbEnv.`env-name`.DbPrivate

### Synopsis

    Freeze.DbEnv.env-name.DbPrivate=num

### Description

If `num` is set to a value larger than zero, Freeze instructs Berkeley DB to use process private memory instead of shared memory. The default value is 1. Set it to 0 in order to run db_archive (or another Berkeley DB utility) on a running environment.

## Freeze.DbEnv.`env-name`.DbRecoverFatal

### Synopsis

    Freeze.DbEnv.env-name.DbRecoverFatal=num

### Description

If `num` is set to a value larger than zero, "fatal" recovery is performed when the environment is opened. The default value is 0.

## Freeze.DbEnv.`env-name`.OldLogsAutoDelete

### Synopsis

    Freeze.DbEnv.env-name.OldLogsAutoDelete=num

### Description

If `num` is set to a value larger than zero, old transactional logs no longer in use are deleted after each periodic checkpoint (see `Freeze.DbEnv.`env-name`.CheckpointPeriod`). The default value is 1.

## Freeze.DbEnv.`env-name`.PeriodicCheckpointMinSize

### Synopsis

    Freeze.DbEnv.env-name.PeriodicCheckpointMinSize=num

### Description

`num` is the minimum size in kbytes for the periodic checkpoint (see `Freeze.DbEnv.`env-name`.CheckpointPeriod`). This value is passed to Berkeley DB's checkpoint function. Defaults to 0 (which means no minimum).

## Freeze.Evictor.`env-name`.`filename`.MaxTxSize

### Synopsis

    Freeze.Evictor.env-name.filename.MaxTxSize=num

### Description

Freeze uses a background thread to save updates to the database. Transactions are used to save many facets together. `num` defines the maximum number of facets saved per transaction. Defaults to 10 * SaveSizeTrigger (see `Freeze.Evictor.`env-name`.`filename`.SaveSizeTrigger`); if this value is negative, the actual value is set to 100.

## Freeze.Evictor.`env-name`.`filename`.PopulateEmptyIndices

### Synopsis

    Freeze.Evictor.env-name.filename.PopulateEmptyIndices=num

### Description

When `num` is not 0 and you create an evictor with one or more empty indices, the createEvictor() call will populate these indices by iterating over all the corresponding facets. This is particularly useful after transforming a Freeze Evictor with FreezeScript, since FreezeScript does not transform indices; however this can significantly slow down createEvictor() if you have an empty index because none of the facets currently in your database match the type of this index. The default value for this property is 0.

## Freeze.Evictor.`env-name`.`filename`.SavePeriod

### Synopsis

    Freeze.Evictor.env-name.filename.SavePeriod=num

### Description

Freeze uses a background thread to save updates to the database. After `num` milliseconds without saving, if there is any facet created, modified or destroyed, this background thread wakes up to save these facets. When `num` is 0, there is no periodic saving. Defaults to 60,000.

## Freeze.Evictor.`env-name`.`filename`.SaveSizeTrigger

### Synopsis

    Freeze.Evictor.env-name.filename.SaveSizeTrigger=num

### Description

Freeze uses a background thread to save updates to the database. When `num` is 0 or positive, as soon as `num` or more facets have been created, modified or destroyed, this background thread wakes up to save them. When `num` is negative, there is no size trigger. Defaults to 10.

## Freeze.Evictor.`env-name`.`filename`.StreamTimeout

### Synopsis

    Freeze.Evictor.env-name.filename.StreamTimeout=num

### Description

When the saving thread saves an object, it needs to lock this object in order to get a consistent copy of the object's state. If the lock cannot be acquired within `num` seconds, a fatal error is generated. If a fatal error callback was registered by the appplication, this callback is called; otherwise the program is terminated immediately. When `num` is 0 or negative, there is no timeout. The default value is 0.

## Freeze.Trace.DbEnv

### Synopsis

    Freeze.Trace.DbEnv=num

### Description

The Freeze database environment activity trace level:

0 | No database environment activity trace. (default)
1 | Trace database open and close.
2 | Also trace checkpoints and the removal of old log files.

## Freeze.Trace.Evictor

### Synopsis

    Freeze.Trace.Evictor=num

### Description

The Freeze evictor activity trace level:

0 | No evictor activity trace. (default)
1 | Trace Ice object and facet creation and destruction, facet streaming time, facet saving time, object eviction (every 50 objects) and evictor deactivation.
2 | Also trace object lookups, and all object evictions.
3 | Also trace object retrieval from the database.

## Freeze.Trace.Map

### Synopsis

    Freeze.Trace.Map=num

### Description

The Freeze map activity trace level:

0 | No map activity trace. (default)
1 | Trace database open and close.
2 | Also trace iterator and transaction operations, and reference counting of the underlying database.

## Freeze.Warn.Deadlocks

### Synopsis

    Freeze.Warn.Deadlocks=num

### Description

If `num` is set to a value larger than zero, Freeze logs a warning message when a deadlock occur. The default value is 0.

## Freeze.Warn.CloseInFinalize

### Synopsis

    Freeze.Warn.CloseInFinalize=num

### Description

If `num` is set to a value larger than zero, Freeze logs a warning message when an application neglects to explicitly close a map iterator. The default value is 1. (Java only)

<<< Previous | Home | Next >>>
Glacier2 Properties | Up | IcePatch2 Properties